# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/weblogic/provider'
require 'puppet_x/enterprisemodules/weblogic/functions'

Puppet::Type.type(:wls_credential).provide(:prefetching) do
  include EasyType::Provider

  include EasyType::Template
  include EasyType::Helpers
  include Puppet_X::EnterpriseModules::WebLogic::Access
  extend Puppet_X::EnterpriseModules::WebLogic::Functions

  confine :exists => '/etc/wls_setting.yaml'
  confine :feature => :weblogic_running

  desc 'Manage wls_credentials'

  mk_resource_methods
  def self.prefetch(resources)
    # objects = instances
    resources.each_key do |name|
      current_resource = resources[name]
      current_values = wlst(template('wls_config/wls_credential/index.py.erb', binding), 'action' => 'index').first
      next if current_values.nil?

      current_resource.provider.property_hash[:ensure] = :present
      current_resource.provider.property_hash[:username] = current_values['username']
      current_resource.provider.property_hash[:password] = current_values['password']
      current_resource.provider.property_hash[:description] = current_values['description']
    end
    resources
  end
end
